package frames;

use strict;

sub getPredicateFrames
{
    my $frames;

    open(FRAMES,"data/pred-frames.file");
    while (my $line=<FRAMES>)
    {
	chop $line;
	my ($predicate, @arguments) = split(/ /,$line);
       	@{ $frames->{$predicate} } = @arguments;
    }
    close(FRAMES);
    
    return $frames;
}


sub unfilledArguments
{
    my $document = $_[0];
    my $frames = $_[1];
    foreach my $sentence_idx (keys %{ $document })
    {
	foreach my $predicate_idx (keys %{ $document->{$sentence_idx}->{predicates} })
	{
	    my $predicate = $document->{$sentence_idx}->{predicates}->{$predicate_idx}->{predicate};
	    foreach my $argument (@{ $frames->{$predicate} })
	    {
		my $explicit_argument = $document->{$sentence_idx}->{predicates}->{$predicate_idx}->{explicit_arg}->{$argument};
		if (not (exists $explicit_argument->{token}))
		{
		    $document->{$sentence_idx}->{predicates}->{$predicate_idx}->{implicit_arg}->{$argument}->{sentence} = "";
		    $document->{$sentence_idx}->{predicates}->{$predicate_idx}->{implicit_arg}->{$argument}->{token} = "";
		}
	    }
	}
    }

    return $document;
}


1;
