package lines;

use modules::candidates;
use modules::filters;
use modules::salience;
use modules::semantics;
use modules::span;

use strict;

sub developLines
{
    my $document = $_[0];

    my $last_filler;

    my $arg_categories = semantics::getArgCategories();

    foreach my $sentence_idx (sort {$a<=>$b} keys %{ $document })
    {
	$last_filler = salience::renegoziateSalience($last_filler,$sentence_idx);
       	foreach my $predicate_idx (sort {$a<=>$b} keys %{ $document->{$sentence_idx}->{predicates} })
	{
	    my $predicate = $document->{$sentence_idx}->{predicates}->{$predicate_idx}->{predicate};
	    my $predicate_token = $document->{$sentence_idx}->{predicates}->{$predicate_idx}->{token_idx};
	    my $predicate_normal = $document->{$sentence_idx}->{predicates}->{$predicate_idx}->{normalization};

	    foreach my $explicit_arg (keys %{ $document->{$sentence_idx}->{predicates}->{$predicate_idx}->{explicit_arg} })
	    {
		my $token = $document->{$sentence_idx}->{predicates}->{$predicate_idx}->{explicit_arg}->{$explicit_arg}->{token};
		
		$last_filler->{$predicate_normal}->{$explicit_arg}->{sentence} = $sentence_idx;
		$last_filler->{$predicate_normal}->{$explicit_arg}->{token} = $token;
		$last_filler->{$predicate_normal}->{$explicit_arg}->{salience} = salience::explicitSalience();
		$last_filler->{$predicate_normal}->{$explicit_arg}->{relative_salience} = $last_filler->{$predicate_normal}->{$explicit_arg}->{salience};
	    }

	    foreach my $implicit_arg (sort keys %{ $document->{$sentence_idx}->{predicates}->{$predicate_idx}->{implicit_arg} })
	    {
		my $filler_candidates;
		$filler_candidates = candidates::nearContext($filler_candidates,$document,$sentence_idx,$predicate_token);
		$filler_candidates = filters::filterCandidates($filler_candidates,$document,$sentence_idx,$predicate_idx,$predicate_token);
		$filler_candidates = filters::matchCategory($filler_candidates,$document,$predicate,$implicit_arg,$arg_categories);
				
		if (exists $last_filler->{$predicate_normal}->{$implicit_arg})
		{
		    $filler_candidates = candidates::includeCandidate($filler_candidates,$last_filler->{$predicate_normal}->{$implicit_arg});
		}
	
		my $most_salient = salience::mostSalient($filler_candidates);
		
		if ($most_salient->{salience} > 0)
		{
		    $document->{$sentence_idx}->{predicates}->{$predicate_idx}->{implicit_arg}->{$implicit_arg}->{sentence} = $most_salient->{sentence};
		    $document->{$sentence_idx}->{predicates}->{$predicate_idx}->{implicit_arg}->{$implicit_arg}->{token} = $most_salient->{token};

		    $last_filler->{$predicate_normal}->{$implicit_arg}->{sentence} = $most_salient->{sentence};
		    $last_filler->{$predicate_normal}->{$implicit_arg}->{token} = $most_salient->{token};
		    $last_filler->{$predicate_normal}->{$implicit_arg}->{salience} = $most_salient->{salience};
		    $last_filler->{$predicate_normal}->{$implicit_arg}->{last_sentence} = $sentence_idx;
		    $last_filler->{$predicate_normal}->{$implicit_arg}->{relative_salience} = $most_salient->{salience};
		}
	    }
	}
    }

    return $document;
}


1;
