package output;

use strict;

sub outputCoNLLformat
{
    my $document = $_[0];


    foreach my $sentence_idx (sort {$a<=>$b} keys %{ $document })
    {
	my $output;
	
	my $predicate_output;
	my $explicit_output;
	foreach my $predicate_idx (keys %{ $document->{$sentence_idx}->{predicates} })
	{
	    my $predicate_token = $document->{$sentence_idx}->{predicates}->{$predicate_idx}->{token_idx};
	    $predicate_output->{$predicate_token}->{predicate} = $document->{$sentence_idx}->{predicates}->{$predicate_idx}->{predicate};
	   
	    foreach my $argument (keys %{ $document->{$sentence_idx}->{predicates}->{$predicate_idx}->{explicit_arg} })
	    {
		my $filler_token = $document->{$sentence_idx}->{predicates}->{$predicate_idx}->{explicit_arg}->{$argument}->{token};
		$explicit_output->{$filler_token}->{$predicate_token} = $argument;
	    }

	    foreach my $argument (keys %{ $document->{$sentence_idx}->{predicates}->{$predicate_idx}->{implicit_arg} })
	    {
		my $filler_sentence = $document->{$sentence_idx}->{predicates}->{$predicate_idx}->{implicit_arg}->{$argument}->{sentence};
		my $filler_token = $document->{$sentence_idx}->{predicates}->{$predicate_idx}->{implicit_arg}->{$argument}->{token};
		if ($filler_token ne "")
		{
		    $predicate_output->{$predicate_token}->{implicit_arg}->{$argument}->{sentence} = $filler_sentence;
		    $predicate_output->{$predicate_token}->{implicit_arg}->{$argument}->{token} = $filler_token;
		}
	    }
	}

	foreach my $token_idx (sort {$a<=>$b} keys %{ $document->{$sentence_idx}->{tokens} })
	{
	    print $token_idx;

	    my $form = $document->{$sentence_idx}->{tokens}->{$token_idx}->{form};
	    my $lemma = $document->{$sentence_idx}->{tokens}->{$token_idx}->{lemma};
	    my $plemma = $document->{$sentence_idx}->{tokens}->{$token_idx}->{plemma};
	    my $pos = $document->{$sentence_idx}->{tokens}->{$token_idx}->{pos};
	    my $ppos = $document->{$sentence_idx}->{tokens}->{$token_idx}->{ppos};
	    my $feat = $document->{$sentence_idx}->{tokens}->{$token_idx}->{feat};
	    my $pfeat = $document->{$sentence_idx}->{tokens}->{$token_idx}->{pfeat};
	    my $head = $document->{$sentence_idx}->{tokens}->{$token_idx}->{head};
	    my $phead = $document->{$sentence_idx}->{tokens}->{$token_idx}->{phead};
	    my $deprel = $document->{$sentence_idx}->{tokens}->{$token_idx}->{deprel};
	    my $pdeprel = $document->{$sentence_idx}->{tokens}->{$token_idx}->{pdeprel};

	    print "\t".$form."\t".$lemma."\t".$plemma."\t".$pos."\t".$ppos."\t".$feat."\t".$pfeat."\t".$head."\t".$phead."\t".$deprel."\t".$pdeprel;

	    my $out_predicate = $predicate_output->{$token_idx};
	    if (exists $out_predicate->{predicate})
	    {
		print "\tY\t".$predicate_output->{$token_idx}->{predicate};
	    }
	    else
	    {
		print "\t_\t_";
	    }

	    foreach my $predicate_token (sort {$a<=>$b} keys %{ $predicate_output })
	    {
		if (exists $explicit_output->{$token_idx}->{$predicate_token})
		{
		    print "\t".$explicit_output->{$token_idx}->{$predicate_token};
		}
		else
		{
		    print "\t_";
		}
	    }

	    if (exists $out_predicate->{predicate})
	    {
		foreach my $argument (keys %{ $predicate_output->{$token_idx}->{implicit_arg} })
		{
		    my $filler_sentence = $predicate_output->{$token_idx}->{implicit_arg}->{$argument}->{sentence};
		    my $filler_token = $predicate_output->{$token_idx}->{implicit_arg}->{$argument}->{token};

		    print "\t".$argument.":".$filler_sentence."-".$filler_token;
		}
	    }
	    
	    print "\n";
	}
	
	print "\n";
    }
}


1;
