package salience;

use strict;


sub explicitSalience
{
    return 500;
}


sub candidateSalience
{
    my $candidate = $_[0];
    my $target_sentence = $_[1];
    my $document = $_[2];

    my $salience=0;

    my $candidate_sentence = $candidate->{sentence};
    my $candidate_token = $candidate->{token};

    my $candidate_deprel = $document->{$candidate_sentence}->{tokens}->{$candidate_token}->{deprel};
    my $candidate_collapsed_deprel = $document->{$candidate_sentence}->{tokens}->{$candidate_token}->{collapsed_deprel};

    # Sentence recency

    if ($target_sentence == $candidate->{sentence})
    {
	$salience=$salience+100;
    }
    
    # Syntactic emphasis

    if ($candidate_collapsed_deprel eq "SBJ")
    {
	$salience=$salience+80;
    }
    elsif ($candidate_collapsed_deprel eq "0BJ")
    {
	$salience=$salience+70;
    }
    elsif ($candidate_collapsed_deprel ne "ADV")
    {
	$salience=$salience+50;
    }

    # Head emphasis

    if ($candidate_collapsed_deprel eq $candidate_deprel)
    {
	$salience=$salience+80;
    }



    return $salience;    
}


sub mostSalient
{
    my $candidates = $_[0];
    
    my $most_salient;

    foreach my $candidate (@{ $candidates })
    {
	if ($most_salient->{relative_salience} eq "" || $candidate->{relative_salience} > $most_salient->{relative_salience})
	{
	    $most_salient->{sentence} = $candidate->{sentence};
	    $most_salient->{token} = $candidate->{token};
	    $most_salient->{salience} = $candidate->{salience};
	    $most_salient->{relative_salience} = $candidate->{relative_salience};
	}
    }

    return $most_salient;
}


sub renegoziateSalience
{
    my $last_filler = $_[0];
    my $sentence_idx = $_[1];

    foreach my $predicate (keys %{ $last_filler })
    {
	foreach my $argument (keys %{ $last_filler->{$predicate} })
	{
	    my $last_sentence = $last_filler->{$predicate}->{$argument}->{last_sentence};
	    my $distance = $sentence_idx - $last_sentence;

	    my $salience = $last_filler->{$predicate}->{$argument}->{salience}; 
	    
	    my $reduction_coeficient;
	    if ($distance == 0)
	    {
		$reduction_coeficient = 1;
	    }
	    else
	    {
		$reduction_coeficient = 0.5**$distance;
	    }
	    
	    my $relative_salience = $salience - 100 + 100 * $reduction_coeficient;	    

	    $last_filler->{$predicate}->{$argument}->{relative_salience} = $relative_salience;
	}
    }

    
    return $last_filler;
}


1;
