#!/usr/bin/perl

use strict;

use modules::document;
use modules::normalization;
use modules::frames;
use modules::lines;
use modules::output;


if ($#ARGV != 1)
{
    die "\nUsage: ./run.perl closed-file open-file\n\n";
}

my $closed_file = $ARGV[0];
my $open_file = $ARGV[1];

my $document = document::getDocumentStructure($closed_file, $open_file);
my $document = document::collapseDependencies($document);

my $normal_forms = normalization::getNormalForms();
my $document = normalization::normalizePredicates($document, $normal_forms);

my $frames = frames::getPredicateFrames();
my $document = frames::unfilledArguments($document, $frames);

my $document = lines::developLines($document);

output::outputCoNLLformat($document);
